<?php

declare(strict_types=1);

namespace Dedi\SyliusStockHistoryPlugin\Entity;

use Sylius\Component\Core\Model\OrderInterface;
use Sylius\Component\Core\Model\ProductVariantInterface;

class InventoryLogEntry implements InventoryLogEntryInterface
{
    protected ?int $id = null;

    protected ProductVariantInterface $variant;

    protected ?OrderInterface $order = null;

    protected \DateTimeImmutable $loggedAt;

    protected string $inventoryName;

    protected ?int $onHand = null;

    protected ?int $onHold = null;

    protected ?int $previousOnHand = null;

    protected ?int $previousOnHold = null;

    protected string $path;

    protected string $type;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getVariant(): ProductVariantInterface
    {
        return $this->variant;
    }

    public function setVariant(ProductVariantInterface $variant): self
    {
        $this->variant = $variant;

        return $this;
    }

    public function getOrder(): ?OrderInterface
    {
        return $this->order;
    }

    public function setOrder(?OrderInterface $order): self
    {
        $this->order = $order;

        return $this;
    }

    public function getLoggedAt(): \DateTimeImmutable
    {
        return $this->loggedAt;
    }

    public function setLoggedAt(\DateTimeImmutable $loggedAt): self
    {
        $this->loggedAt = $loggedAt;

        return $this;
    }

    public function getInventoryName(): string
    {
        return $this->inventoryName;
    }

    public function setInventoryName(string $inventoryName): self
    {
        $this->inventoryName = $inventoryName;

        return $this;
    }

    public function getOnHand(): ?int
    {
        return $this->onHand;
    }

    public function setOnHand(?int $onHand): self
    {
        $this->onHand = $onHand;

        return $this;
    }

    public function getOnHold(): ?int
    {
        return $this->onHold;
    }

    public function setOnHold(?int $onHold): self
    {
        $this->onHold = $onHold;

        return $this;
    }

    public function getPreviousOnHand(): ?int
    {
        return $this->previousOnHand;
    }

    public function setPreviousOnHand(?int $previousOnHand): self
    {
        $this->previousOnHand = $previousOnHand;

        return $this;
    }

    public function getPreviousOnHold(): ?int
    {
        return $this->previousOnHold;
    }

    public function setPreviousOnHold(?int $previousOnHold): self
    {
        $this->previousOnHold = $previousOnHold;

        return $this;
    }

    public function getPath(): string
    {
        return $this->path;
    }

    public function setPath(string $path): self
    {
        $this->path = $path;

        return $this;
    }

    public function getType(): string
    {
        return $this->type;
    }

    public function setType(string $type): self
    {
        $this->type = $type;

        return $this;
    }
}
